#pragma once
#ifndef __IMPLICIT_EULER__H__
#define __IMPLICIT_EULER__H__

#include "tetramesh.h"


void integrationMatrixImplicitEuler(Mesh& m);
void integrationImplicitEuler(Mesh& m);



inline DclVector mult(const DclMatrix33& m, const DclVector& v)
{
	return DclVector(m(0, 0)*v.x + m(0, 1)*v.y + m(0, 2)*v.z,
					 m(1, 0)*v.x + m(1, 1)*v.y + m(1, 2)*v.z,
					 m(2, 0)*v.x + m(2, 1)*v.y + m(2, 2)*v.z);
}

inline void mult_assign(DclVector& result, const DclMatrix33& m, const DclVector& v)
{
	result.x = m(0, 0)*v.x + m(0, 1)*v.y + m(0, 2)*v.z;
	result.y = m(1, 0)*v.x + m(1, 1)*v.y + m(1, 2)*v.z;
	result.z = m(2, 0)*v.x + m(2, 1)*v.y + m(2, 2)*v.z;
}

inline DclMatrix33 multTranspose(const DclVector& a, const DclVector& b)
{
	return DclMatrix33(b*a.x, b*a.y, b*a.z);
}

#endif // __IMPLICIT_EULER__H__
