#pragma once
#ifndef __DEFINITIONS_H__
#define __DEFINITIONS_H__

#include "vector.h"
#include "particle.h"



#define FIXED_FRAME_RATE



///////////////////////////////////////////////////

static const int NUM_FACE_INDICES_PER_PARTICLE = 4*8;
static const int NUM_FACES_PER_PARTICLE = 8;
static const int NUM_VERTICES_PER_PARTICLE = 7;

///////////////////////////////////////////////////

static const size_t NUM_PARTICLES = 500;

// Integration step h
static const DclFloat DEFAULT_TIMESTEP = 0.001;

// Elasticity of collision with walls
static const DclFloat WORLD_ELASTICITY = 1.0;

static const DclFloat G = 9.81;


/////////////////////////////////////////////////
// Viewer constants
/////////////////////////////////////////////////

static const DclFloat WORLD_WIDTH = 10.0;
static const DclFloat WORLD_DEPTH = 10.0;
static const DclFloat WORLD_HEIGHT = 10.0;

static const DclFloat WORLD_RED = 1.0;
static const DclFloat WORLD_GREEN = 0.9;
static const DclFloat WORLD_BLUE = 0.9;

static const DclFloat LIGHT_X = 1.0;
static const DclFloat LIGHT_Y = 2.0;
static const DclFloat LIGHT_Z = 1.0;

static const DclFloat CAMERA_X = 0.0;
static const DclFloat CAMERA_Y = 0.0;
static const DclFloat CAMERA_Z = 14.0;

static const int WINDOW_WIDTH = 1024;
static const int WINDOW_HEIGHT = 768;

static const int MAX_NUM_PARTICLES = 10000;

static const int DESIRED_FRAME_RATE = 60;
static const int DESIRED_FRAME_DURATION = 1000 / DESIRED_FRAME_RATE;

static const DclFloat DEFAULT_SPRING_CONSTANT = 10000.0;
static const DclFloat DEFAULT_SPRING_DAMPING_CONSTANT = 1.0;
static const DclFloat DEFAULT_VOLUME_CONSTANT = 1500.0;

static const size_t IMPLICIT_EULER_MAX_ITERATIONS = 3;
static const DclFloat IMPLICIT_EULER_EPSILON = 10e-8;

static const char* DEFAULT_MESH = "cube.dcstructure";

////////////////////////////////////////////////////


#endif // __DEFINITIONS_H__
