#include "precisetimer.h"
#include <windows.h>


performance_counter::value_type performance_counter::frequency()
{
	value_type frequency;
	::QueryPerformanceFrequency((LARGE_INTEGER*)&frequency);
	return frequency;
}

performance_counter::value_type performance_counter::value()
{
	value_type value;
	::QueryPerformanceCounter((LARGE_INTEGER*)&value);
	return value;
}

performance_counter::value_type performance_counter::ms(const value_type& value)
{
	return (1000i64 * value) / performance_counter::frequency();
}

performance_counter::value_type performance_counter::from_ms(const value_type& value)
{
	return (performance_counter::frequency() * value) / 1000i64;
}
