#pragma once
#ifndef __TETRAMESH_H__
#define __TETRAMESH_H__

#include <vector>
#include "particle.h"
#include "matrix33.h"


struct Tetrahedron
{
	int p1, p2, p3, p4;
	DclFloat initialVolume;
	DclFloat initialArea1;
	DclFloat initialArea2;
	DclFloat initialArea3;
	DclFloat initialArea4;
};

struct Spring
{
	int p1, p2;

	DclFloat initialLength;
	DclMatrix33 J;
};

struct Mesh
{
	Integration integration;
	DclFloat  r, g, b;
	DclFloat h;
	DclFloat springConstant;
	DclFloat springDampingConstant;
	DclFloat volumeConstant;

	std::vector<Tetrahedron> vectorTetrahedra;
	std::vector<Spring> vectorSprings;
	std::vector<Particle> vectorParticles;
};

extern std::vector<Mesh> vectorMeshes;

#endif // __TETRAMESH_H__
